package cn.com.infosec.jce;

import cn.com.infosec.x509.X509StoreParameters;
import java.security.cert.CertStoreParameters;
import java.security.cert.LDAPCertStoreParameters;

public class X509LDAPCertStoreParameters implements X509StoreParameters, CertStoreParameters {
   private String ldapURL;
   private String baseDN;
   private String userCertificateAttribute;
   private String cACertificateAttribute;
   private String crossCertificateAttribute;
   private String certificateRevocationListAttribute;
   private String deltaRevocationListAttribute;
   private String authorityRevocationListAttribute;
   private String attributeCertificateAttributeAttribute;
   private String aACertificateAttribute;
   private String attributeDescriptorCertificateAttribute;
   private String attributeCertificateRevocationListAttribute;
   private String attributeAuthorityRevocationListAttribute;
   private String ldapUserCertificateAttributeName;
   private String ldapCACertificateAttributeName;
   private String ldapCrossCertificateAttributeName;
   private String ldapCertificateRevocationListAttributeName;
   private String ldapDeltaRevocationListAttributeName;
   private String ldapAuthorityRevocationListAttributeName;
   private String ldapAttributeCertificateAttributeAttributeName;
   private String ldapAACertificateAttributeName;
   private String ldapAttributeDescriptorCertificateAttributeName;
   private String ldapAttributeCertificateRevocationListAttributeName;
   private String ldapAttributeAuthorityRevocationListAttributeName;
   private String userCertificateSubjectAttributeName;
   private String cACertificateSubjectAttributeName;
   private String crossCertificateSubjectAttributeName;
   private String certificateRevocationListIssuerAttributeName;
   private String deltaRevocationListIssuerAttributeName;
   private String authorityRevocationListIssuerAttributeName;
   private String attributeCertificateAttributeSubjectAttributeName;
   private String aACertificateSubjectAttributeName;
   private String attributeDescriptorCertificateSubjectAttributeName;
   private String attributeCertificateRevocationListIssuerAttributeName;
   private String attributeAuthorityRevocationListIssuerAttributeName;
   private String searchForSerialNumberIn;

   private X509LDAPCertStoreParameters(Builder builder) {
      this.ldapURL = builder.ldapURL;
      this.baseDN = builder.baseDN;
      this.userCertificateAttribute = builder.userCertificateAttribute;
      this.cACertificateAttribute = builder.cACertificateAttribute;
      this.crossCertificateAttribute = builder.crossCertificateAttribute;
      this.certificateRevocationListAttribute = builder.certificateRevocationListAttribute;
      this.deltaRevocationListAttribute = builder.deltaRevocationListAttribute;
      this.authorityRevocationListAttribute = builder.authorityRevocationListAttribute;
      this.attributeCertificateAttributeAttribute = builder.attributeCertificateAttributeAttribute;
      this.aACertificateAttribute = builder.aACertificateAttribute;
      this.attributeDescriptorCertificateAttribute = builder.attributeDescriptorCertificateAttribute;
      this.attributeCertificateRevocationListAttribute = builder.attributeCertificateRevocationListAttribute;
      this.attributeAuthorityRevocationListAttribute = builder.attributeAuthorityRevocationListAttribute;
      this.ldapUserCertificateAttributeName = builder.ldapUserCertificateAttributeName;
      this.ldapCACertificateAttributeName = builder.ldapCACertificateAttributeName;
      this.ldapCrossCertificateAttributeName = builder.ldapCrossCertificateAttributeName;
      this.ldapCertificateRevocationListAttributeName = builder.ldapCertificateRevocationListAttributeName;
      this.ldapDeltaRevocationListAttributeName = builder.ldapDeltaRevocationListAttributeName;
      this.ldapAuthorityRevocationListAttributeName = builder.ldapAuthorityRevocationListAttributeName;
      this.ldapAttributeCertificateAttributeAttributeName = builder.ldapAttributeCertificateAttributeAttributeName;
      this.ldapAACertificateAttributeName = builder.ldapAACertificateAttributeName;
      this.ldapAttributeDescriptorCertificateAttributeName = builder.ldapAttributeDescriptorCertificateAttributeName;
      this.ldapAttributeCertificateRevocationListAttributeName = builder.ldapAttributeCertificateRevocationListAttributeName;
      this.ldapAttributeAuthorityRevocationListAttributeName = builder.ldapAttributeAuthorityRevocationListAttributeName;
      this.userCertificateSubjectAttributeName = builder.userCertificateSubjectAttributeName;
      this.cACertificateSubjectAttributeName = builder.cACertificateSubjectAttributeName;
      this.crossCertificateSubjectAttributeName = builder.crossCertificateSubjectAttributeName;
      this.certificateRevocationListIssuerAttributeName = builder.certificateRevocationListIssuerAttributeName;
      this.deltaRevocationListIssuerAttributeName = builder.deltaRevocationListIssuerAttributeName;
      this.authorityRevocationListIssuerAttributeName = builder.authorityRevocationListIssuerAttributeName;
      this.attributeCertificateAttributeSubjectAttributeName = builder.attributeCertificateAttributeSubjectAttributeName;
      this.aACertificateSubjectAttributeName = builder.aACertificateSubjectAttributeName;
      this.attributeDescriptorCertificateSubjectAttributeName = builder.attributeDescriptorCertificateSubjectAttributeName;
      this.attributeCertificateRevocationListIssuerAttributeName = builder.attributeCertificateRevocationListIssuerAttributeName;
      this.attributeAuthorityRevocationListIssuerAttributeName = builder.attributeAuthorityRevocationListIssuerAttributeName;
      this.searchForSerialNumberIn = builder.searchForSerialNumberIn;
   }

   private boolean checkField(Object o1, Object o2) {
      if (o1 == o2) {
         return true;
      } else {
         return o1 == null ? false : o1.equals(o2);
      }
   }

   private int addHashCode(int hashCode, Object o) {
      int var3 = hashCode * 29;
      if (o == null) {
         hashCode = 0;
      } else {
         hashCode = o.hashCode();
      }

      return var3 + hashCode;
   }

   public static X509LDAPCertStoreParameters getInstance(LDAPCertStoreParameters params) {
      String params1 = "ldap://" + params.getServerName() + ":" + params.getPort();
      return (new Builder(params1, "")).build();
   }

   // $FF: synthetic method
   X509LDAPCertStoreParameters(Builder var1, X509LDAPCertStoreParameters var2) {
      this(var1);
   }

   public Object clone() {
      return this;
   }

   public boolean equal(Object o) {
      if (o == this) {
         return true;
      } else if (!(o instanceof X509LDAPCertStoreParameters)) {
         return false;
      } else {
         X509LDAPCertStoreParameters o1;
         X509LDAPCertStoreParameters var10001 = o1 = (X509LDAPCertStoreParameters)o;
         String var2 = this.ldapURL;
         if (this.checkField(var2, var10001.ldapURL)) {
            var2 = this.baseDN;
            if (this.checkField(var2, o1.baseDN)) {
               var2 = this.userCertificateAttribute;
               if (this.checkField(var2, o1.userCertificateAttribute)) {
                  var2 = this.cACertificateAttribute;
                  if (this.checkField(var2, o1.cACertificateAttribute)) {
                     var2 = this.crossCertificateAttribute;
                     if (this.checkField(var2, o1.crossCertificateAttribute)) {
                        var2 = this.certificateRevocationListAttribute;
                        if (this.checkField(var2, o1.certificateRevocationListAttribute)) {
                           var2 = this.deltaRevocationListAttribute;
                           if (this.checkField(var2, o1.deltaRevocationListAttribute)) {
                              var2 = this.authorityRevocationListAttribute;
                              if (this.checkField(var2, o1.authorityRevocationListAttribute)) {
                                 var2 = this.attributeCertificateAttributeAttribute;
                                 if (this.checkField(var2, o1.attributeCertificateAttributeAttribute)) {
                                    var2 = this.aACertificateAttribute;
                                    if (this.checkField(var2, o1.aACertificateAttribute)) {
                                       var2 = this.attributeDescriptorCertificateAttribute;
                                       if (this.checkField(var2, o1.attributeDescriptorCertificateAttribute)) {
                                          var2 = this.attributeCertificateRevocationListAttribute;
                                          if (this.checkField(var2, o1.attributeCertificateRevocationListAttribute)) {
                                             var2 = this.attributeAuthorityRevocationListAttribute;
                                             if (this.checkField(var2, o1.attributeAuthorityRevocationListAttribute)) {
                                                var2 = this.ldapUserCertificateAttributeName;
                                                if (this.checkField(var2, o1.ldapUserCertificateAttributeName)) {
                                                   var2 = this.ldapCACertificateAttributeName;
                                                   if (this.checkField(var2, o1.ldapCACertificateAttributeName)) {
                                                      var2 = this.ldapCrossCertificateAttributeName;
                                                      if (this.checkField(var2, o1.ldapCrossCertificateAttributeName)) {
                                                         var2 = this.ldapCertificateRevocationListAttributeName;
                                                         if (this.checkField(var2, o1.ldapCertificateRevocationListAttributeName)) {
                                                            var2 = this.ldapDeltaRevocationListAttributeName;
                                                            if (this.checkField(var2, o1.ldapDeltaRevocationListAttributeName)) {
                                                               var2 = this.ldapAuthorityRevocationListAttributeName;
                                                               if (this.checkField(var2, o1.ldapAuthorityRevocationListAttributeName)) {
                                                                  var2 = this.ldapAttributeCertificateAttributeAttributeName;
                                                                  if (this.checkField(var2, o1.ldapAttributeCertificateAttributeAttributeName)) {
                                                                     var2 = this.ldapAACertificateAttributeName;
                                                                     if (this.checkField(var2, o1.ldapAACertificateAttributeName)) {
                                                                        var2 = this.ldapAttributeDescriptorCertificateAttributeName;
                                                                        if (this.checkField(var2, o1.ldapAttributeDescriptorCertificateAttributeName)) {
                                                                           var2 = this.ldapAttributeCertificateRevocationListAttributeName;
                                                                           if (this.checkField(var2, o1.ldapAttributeCertificateRevocationListAttributeName)) {
                                                                              var2 = this.ldapAttributeAuthorityRevocationListAttributeName;
                                                                              if (this.checkField(var2, o1.ldapAttributeAuthorityRevocationListAttributeName)) {
                                                                                 var2 = this.userCertificateSubjectAttributeName;
                                                                                 if (this.checkField(var2, o1.userCertificateSubjectAttributeName)) {
                                                                                    var2 = this.cACertificateSubjectAttributeName;
                                                                                    if (this.checkField(var2, o1.cACertificateSubjectAttributeName)) {
                                                                                       var2 = this.crossCertificateSubjectAttributeName;
                                                                                       if (this.checkField(var2, o1.crossCertificateSubjectAttributeName)) {
                                                                                          var2 = this.certificateRevocationListIssuerAttributeName;
                                                                                          if (this.checkField(var2, o1.certificateRevocationListIssuerAttributeName)) {
                                                                                             var2 = this.deltaRevocationListIssuerAttributeName;
                                                                                             if (this.checkField(var2, o1.deltaRevocationListIssuerAttributeName)) {
                                                                                                var2 = this.authorityRevocationListIssuerAttributeName;
                                                                                                if (this.checkField(var2, o1.authorityRevocationListIssuerAttributeName)) {
                                                                                                   var2 = this.attributeCertificateAttributeSubjectAttributeName;
                                                                                                   if (this.checkField(var2, o1.attributeCertificateAttributeSubjectAttributeName)) {
                                                                                                      var2 = this.aACertificateSubjectAttributeName;
                                                                                                      if (this.checkField(var2, o1.aACertificateSubjectAttributeName)) {
                                                                                                         var2 = this.attributeDescriptorCertificateSubjectAttributeName;
                                                                                                         if (this.checkField(var2, o1.attributeDescriptorCertificateSubjectAttributeName)) {
                                                                                                            var2 = this.attributeCertificateRevocationListIssuerAttributeName;
                                                                                                            if (this.checkField(var2, o1.attributeCertificateRevocationListIssuerAttributeName)) {
                                                                                                               var2 = this.attributeAuthorityRevocationListIssuerAttributeName;
                                                                                                               if (this.checkField(var2, o1.attributeAuthorityRevocationListIssuerAttributeName)) {
                                                                                                                  X509LDAPCertStoreParameters var10000 = this;
                                                                                                                  String var3 = this.searchForSerialNumberIn;
                                                                                                                  if (var10000.checkField(var3, o1.searchForSerialNumberIn)) {
                                                                                                                     return true;
                                                                                                                  }
                                                                                                               }
                                                                                                            }
                                                                                                         }
                                                                                                      }
                                                                                                   }
                                                                                                }
                                                                                             }
                                                                                          }
                                                                                       }
                                                                                    }
                                                                                 }
                                                                              }
                                                                           }
                                                                        }
                                                                     }
                                                                  }
                                                               }
                                                            }
                                                         }
                                                      }
                                                   }
                                                }
                                             }
                                          }
                                       }
                                    }
                                 }
                              }
                           }
                        }
                     }
                  }
               }
            }
         }

         return false;
      }
   }

   public int hashCode() {
      X509LDAPCertStoreParameters var10000 = this;
      X509LDAPCertStoreParameters var10001 = this;
      X509LDAPCertStoreParameters var10002 = this;
      X509LDAPCertStoreParameters var10003 = this;
      X509LDAPCertStoreParameters var10004 = this;
      X509LDAPCertStoreParameters var10005 = this;
      X509LDAPCertStoreParameters var10006 = this;
      X509LDAPCertStoreParameters var10007 = this;
      X509LDAPCertStoreParameters var10008 = this;
      X509LDAPCertStoreParameters var10009 = this;
      X509LDAPCertStoreParameters var10010 = this;
      X509LDAPCertStoreParameters var10011 = this;
      X509LDAPCertStoreParameters var10012 = this;
      X509LDAPCertStoreParameters var10013 = this;
      X509LDAPCertStoreParameters var10014 = this;
      X509LDAPCertStoreParameters var10015 = this;
      X509LDAPCertStoreParameters var10016 = this;
      X509LDAPCertStoreParameters var10017 = this;
      X509LDAPCertStoreParameters var10018 = this;
      X509LDAPCertStoreParameters var10019 = this;
      X509LDAPCertStoreParameters var10020 = this;
      X509LDAPCertStoreParameters var10021 = this;
      X509LDAPCertStoreParameters var10022 = this;
      X509LDAPCertStoreParameters var10023 = this;
      X509LDAPCertStoreParameters var10024 = this;
      X509LDAPCertStoreParameters var10025 = this;
      X509LDAPCertStoreParameters var10026 = this;
      X509LDAPCertStoreParameters var10027 = this;
      X509LDAPCertStoreParameters var10028 = this;
      X509LDAPCertStoreParameters var10029 = this;
      X509LDAPCertStoreParameters var10030 = this;
      X509LDAPCertStoreParameters var10031 = this;
      X509LDAPCertStoreParameters var10032 = this;
      X509LDAPCertStoreParameters var10033 = this;
      X509LDAPCertStoreParameters var10034 = this;
      X509LDAPCertStoreParameters var10035 = this;
      X509LDAPCertStoreParameters var10036 = this;
      X509LDAPCertStoreParameters var10037 = this;
      X509LDAPCertStoreParameters var10038 = this;
      X509LDAPCertStoreParameters var10039 = this;
      X509LDAPCertStoreParameters var10040 = this;
      X509LDAPCertStoreParameters var10041 = this;
      X509LDAPCertStoreParameters var10042 = this;
      X509LDAPCertStoreParameters var10043 = this;
      X509LDAPCertStoreParameters var10044 = this;
      X509LDAPCertStoreParameters var10045 = this;
      X509LDAPCertStoreParameters var10046 = this;
      X509LDAPCertStoreParameters var10047 = this;
      X509LDAPCertStoreParameters var10048 = this;
      X509LDAPCertStoreParameters var10049 = this;
      X509LDAPCertStoreParameters var10050 = this;
      X509LDAPCertStoreParameters var10051 = this;
      X509LDAPCertStoreParameters var10052 = this;
      X509LDAPCertStoreParameters var10053 = this;
      X509LDAPCertStoreParameters var10054 = this;
      X509LDAPCertStoreParameters var10055 = this;
      X509LDAPCertStoreParameters var10056 = this;
      X509LDAPCertStoreParameters var10057 = this;
      X509LDAPCertStoreParameters var10058 = this;
      X509LDAPCertStoreParameters var10059 = this;
      X509LDAPCertStoreParameters var10060 = this;
      X509LDAPCertStoreParameters var10061 = this;
      X509LDAPCertStoreParameters var10062 = this;
      X509LDAPCertStoreParameters var10063 = this;
      X509LDAPCertStoreParameters var10064 = this;
      X509LDAPCertStoreParameters var10065 = this;
      int var1 = this.addHashCode(0, this.userCertificateAttribute);
      var1 = var10064.addHashCode(var1, var10065.cACertificateAttribute);
      var1 = var10062.addHashCode(var1, var10063.crossCertificateAttribute);
      var1 = var10060.addHashCode(var1, var10061.certificateRevocationListAttribute);
      var1 = var10058.addHashCode(var1, var10059.deltaRevocationListAttribute);
      var1 = var10056.addHashCode(var1, var10057.authorityRevocationListAttribute);
      var1 = var10054.addHashCode(var1, var10055.attributeCertificateAttributeAttribute);
      var1 = var10052.addHashCode(var1, var10053.aACertificateAttribute);
      var1 = var10050.addHashCode(var1, var10051.attributeDescriptorCertificateAttribute);
      var1 = var10048.addHashCode(var1, var10049.attributeCertificateRevocationListAttribute);
      var1 = var10046.addHashCode(var1, var10047.attributeAuthorityRevocationListAttribute);
      var1 = var10044.addHashCode(var1, var10045.ldapUserCertificateAttributeName);
      var1 = var10042.addHashCode(var1, var10043.ldapCACertificateAttributeName);
      var1 = var10040.addHashCode(var1, var10041.ldapCrossCertificateAttributeName);
      var1 = var10038.addHashCode(var1, var10039.ldapCertificateRevocationListAttributeName);
      var1 = var10036.addHashCode(var1, var10037.ldapDeltaRevocationListAttributeName);
      var1 = var10034.addHashCode(var1, var10035.ldapAuthorityRevocationListAttributeName);
      var1 = var10032.addHashCode(var1, var10033.ldapAttributeCertificateAttributeAttributeName);
      var1 = var10030.addHashCode(var1, var10031.ldapAACertificateAttributeName);
      var1 = var10028.addHashCode(var1, var10029.ldapAttributeDescriptorCertificateAttributeName);
      var1 = var10026.addHashCode(var1, var10027.ldapAttributeCertificateRevocationListAttributeName);
      var1 = var10024.addHashCode(var1, var10025.ldapAttributeAuthorityRevocationListAttributeName);
      var1 = var10022.addHashCode(var1, var10023.userCertificateSubjectAttributeName);
      var1 = var10020.addHashCode(var1, var10021.cACertificateSubjectAttributeName);
      var1 = var10018.addHashCode(var1, var10019.crossCertificateSubjectAttributeName);
      var1 = var10016.addHashCode(var1, var10017.certificateRevocationListIssuerAttributeName);
      var1 = var10014.addHashCode(var1, var10015.deltaRevocationListIssuerAttributeName);
      var1 = var10012.addHashCode(var1, var10013.authorityRevocationListIssuerAttributeName);
      var1 = var10010.addHashCode(var1, var10011.attributeCertificateAttributeSubjectAttributeName);
      var1 = var10008.addHashCode(var1, var10009.aACertificateSubjectAttributeName);
      var1 = var10006.addHashCode(var1, var10007.attributeDescriptorCertificateSubjectAttributeName);
      var1 = var10004.addHashCode(var1, var10005.attributeCertificateRevocationListIssuerAttributeName);
      var1 = var10002.addHashCode(var1, var10003.attributeAuthorityRevocationListIssuerAttributeName);
      return var10000.addHashCode(var1, var10001.searchForSerialNumberIn);
   }

   public String getAACertificateAttribute() {
      return this.aACertificateAttribute;
   }

   public String getAACertificateSubjectAttributeName() {
      return this.aACertificateSubjectAttributeName;
   }

   public String getAttributeAuthorityRevocationListAttribute() {
      return this.attributeAuthorityRevocationListAttribute;
   }

   public String getAttributeAuthorityRevocationListIssuerAttributeName() {
      return this.attributeAuthorityRevocationListIssuerAttributeName;
   }

   public String getAttributeCertificateAttributeAttribute() {
      return this.attributeCertificateAttributeAttribute;
   }

   public String getAttributeCertificateAttributeSubjectAttributeName() {
      return this.attributeCertificateAttributeSubjectAttributeName;
   }

   public String getAttributeCertificateRevocationListAttribute() {
      return this.attributeCertificateRevocationListAttribute;
   }

   public String getAttributeCertificateRevocationListIssuerAttributeName() {
      return this.attributeCertificateRevocationListIssuerAttributeName;
   }

   public String getAttributeDescriptorCertificateAttribute() {
      return this.attributeDescriptorCertificateAttribute;
   }

   public String getAttributeDescriptorCertificateSubjectAttributeName() {
      return this.attributeDescriptorCertificateSubjectAttributeName;
   }

   public String getAuthorityRevocationListAttribute() {
      return this.authorityRevocationListAttribute;
   }

   public String getAuthorityRevocationListIssuerAttributeName() {
      return this.authorityRevocationListIssuerAttributeName;
   }

   public String getBaseDN() {
      return this.baseDN;
   }

   public String getCACertificateAttribute() {
      return this.cACertificateAttribute;
   }

   public String getCACertificateSubjectAttributeName() {
      return this.cACertificateSubjectAttributeName;
   }

   public String getCertificateRevocationListAttribute() {
      return this.certificateRevocationListAttribute;
   }

   public String getCertificateRevocationListIssuerAttributeName() {
      return this.certificateRevocationListIssuerAttributeName;
   }

   public String getCrossCertificateAttribute() {
      return this.crossCertificateAttribute;
   }

   public String getCrossCertificateSubjectAttributeName() {
      return this.crossCertificateSubjectAttributeName;
   }

   public String getDeltaRevocationListAttribute() {
      return this.deltaRevocationListAttribute;
   }

   public String getDeltaRevocationListIssuerAttributeName() {
      return this.deltaRevocationListIssuerAttributeName;
   }

   public String getLdapAACertificateAttributeName() {
      return this.ldapAACertificateAttributeName;
   }

   public String getLdapAttributeAuthorityRevocationListAttributeName() {
      return this.ldapAttributeAuthorityRevocationListAttributeName;
   }

   public String getLdapAttributeCertificateAttributeAttributeName() {
      return this.ldapAttributeCertificateAttributeAttributeName;
   }

   public String getLdapAttributeCertificateRevocationListAttributeName() {
      return this.ldapAttributeCertificateRevocationListAttributeName;
   }

   public String getLdapAttributeDescriptorCertificateAttributeName() {
      return this.ldapAttributeDescriptorCertificateAttributeName;
   }

   public String getLdapAuthorityRevocationListAttributeName() {
      return this.ldapAuthorityRevocationListAttributeName;
   }

   public String getLdapCACertificateAttributeName() {
      return this.ldapCACertificateAttributeName;
   }

   public String getLdapCertificateRevocationListAttributeName() {
      return this.ldapCertificateRevocationListAttributeName;
   }

   public String getLdapCrossCertificateAttributeName() {
      return this.ldapCrossCertificateAttributeName;
   }

   public String getLdapDeltaRevocationListAttributeName() {
      return this.ldapDeltaRevocationListAttributeName;
   }

   public String getLdapURL() {
      return this.ldapURL;
   }

   public String getLdapUserCertificateAttributeName() {
      return this.ldapUserCertificateAttributeName;
   }

   public String getSearchForSerialNumberIn() {
      return this.searchForSerialNumberIn;
   }

   public String getUserCertificateAttribute() {
      return this.userCertificateAttribute;
   }

   public String getUserCertificateSubjectAttributeName() {
      return this.userCertificateSubjectAttributeName;
   }

   public static class Builder {
      private String ldapURL;
      private String baseDN;
      private String userCertificateAttribute;
      private String cACertificateAttribute;
      private String crossCertificateAttribute;
      private String certificateRevocationListAttribute;
      private String deltaRevocationListAttribute;
      private String authorityRevocationListAttribute;
      private String attributeCertificateAttributeAttribute;
      private String aACertificateAttribute;
      private String attributeDescriptorCertificateAttribute;
      private String attributeCertificateRevocationListAttribute;
      private String attributeAuthorityRevocationListAttribute;
      private String ldapUserCertificateAttributeName;
      private String ldapCACertificateAttributeName;
      private String ldapCrossCertificateAttributeName;
      private String ldapCertificateRevocationListAttributeName;
      private String ldapDeltaRevocationListAttributeName;
      private String ldapAuthorityRevocationListAttributeName;
      private String ldapAttributeCertificateAttributeAttributeName;
      private String ldapAACertificateAttributeName;
      private String ldapAttributeDescriptorCertificateAttributeName;
      private String ldapAttributeCertificateRevocationListAttributeName;
      private String ldapAttributeAuthorityRevocationListAttributeName;
      private String userCertificateSubjectAttributeName;
      private String cACertificateSubjectAttributeName;
      private String crossCertificateSubjectAttributeName;
      private String certificateRevocationListIssuerAttributeName;
      private String deltaRevocationListIssuerAttributeName;
      private String authorityRevocationListIssuerAttributeName;
      private String attributeCertificateAttributeSubjectAttributeName;
      private String aACertificateSubjectAttributeName;
      private String attributeDescriptorCertificateSubjectAttributeName;
      private String attributeCertificateRevocationListIssuerAttributeName;
      private String attributeAuthorityRevocationListIssuerAttributeName;
      private String searchForSerialNumberIn;

      public Builder() {
         this("ldap://localhost:389", "");
      }

      public Builder(String ldapURL, String baseDN) {
         this.ldapURL = ldapURL;
         if (baseDN == null) {
            this.baseDN = "";
         } else {
            this.baseDN = baseDN;
         }

         this.userCertificateAttribute = "userCertificate";
         this.cACertificateAttribute = "cACertificate";
         this.crossCertificateAttribute = "crossCertificatePair";
         this.certificateRevocationListAttribute = "certificateRevocationList";
         this.deltaRevocationListAttribute = "deltaRevocationList";
         this.authorityRevocationListAttribute = "authorityRevocationList";
         this.attributeCertificateAttributeAttribute = "attributeCertificateAttribute";
         this.aACertificateAttribute = "aACertificate";
         this.attributeDescriptorCertificateAttribute = "attributeDescriptorCertificate";
         this.attributeCertificateRevocationListAttribute = "attributeCertificateRevocationList";
         this.attributeAuthorityRevocationListAttribute = "attributeAuthorityRevocationList";
         this.ldapUserCertificateAttributeName = "cn";
         this.ldapCACertificateAttributeName = "cn ou o";
         this.ldapCrossCertificateAttributeName = "cn ou o";
         this.ldapCertificateRevocationListAttributeName = "cn ou o";
         this.ldapDeltaRevocationListAttributeName = "cn ou o";
         this.ldapAuthorityRevocationListAttributeName = "cn ou o";
         this.ldapAttributeCertificateAttributeAttributeName = "cn";
         this.ldapAACertificateAttributeName = "cn o ou";
         this.ldapAttributeDescriptorCertificateAttributeName = "cn o ou";
         this.ldapAttributeCertificateRevocationListAttributeName = "cn o ou";
         this.ldapAttributeAuthorityRevocationListAttributeName = "cn o ou";
         this.userCertificateSubjectAttributeName = "cn";
         this.cACertificateSubjectAttributeName = "o ou";
         this.crossCertificateSubjectAttributeName = "o ou";
         this.certificateRevocationListIssuerAttributeName = "o ou";
         this.deltaRevocationListIssuerAttributeName = "o ou";
         this.authorityRevocationListIssuerAttributeName = "o ou";
         this.attributeCertificateAttributeSubjectAttributeName = "cn";
         this.aACertificateSubjectAttributeName = "o ou";
         this.attributeDescriptorCertificateSubjectAttributeName = "o ou";
         this.attributeCertificateRevocationListIssuerAttributeName = "o ou";
         this.attributeAuthorityRevocationListIssuerAttributeName = "o ou";
         this.searchForSerialNumberIn = "uid serialNumber cn";
      }

      public Builder setUserCertificateAttribute(String userCertificateAttribute) {
         this.userCertificateAttribute = userCertificateAttribute;
         return this;
      }

      public Builder setCACertificateAttribute(String cACertificateAttribute) {
         this.cACertificateAttribute = cACertificateAttribute;
         return this;
      }

      public Builder setCrossCertificateAttribute(String crossCertificateAttribute) {
         this.crossCertificateAttribute = crossCertificateAttribute;
         return this;
      }

      public Builder setCertificateRevocationListAttribute(String certificateRevocationListAttribute) {
         this.certificateRevocationListAttribute = certificateRevocationListAttribute;
         return this;
      }

      public Builder setDeltaRevocationListAttribute(String deltaRevocationListAttribute) {
         this.deltaRevocationListAttribute = deltaRevocationListAttribute;
         return this;
      }

      public Builder setAuthorityRevocationListAttribute(String authorityRevocationListAttribute) {
         this.authorityRevocationListAttribute = authorityRevocationListAttribute;
         return this;
      }

      public Builder setAttributeCertificateAttributeAttribute(String attributeCertificateAttributeAttribute) {
         this.attributeCertificateAttributeAttribute = attributeCertificateAttributeAttribute;
         return this;
      }

      public Builder setAACertificateAttribute(String aACertificateAttribute) {
         this.aACertificateAttribute = aACertificateAttribute;
         return this;
      }

      public Builder setAttributeDescriptorCertificateAttribute(String attributeDescriptorCertificateAttribute) {
         this.attributeDescriptorCertificateAttribute = attributeDescriptorCertificateAttribute;
         return this;
      }

      public Builder setAttributeCertificateRevocationListAttribute(String attributeCertificateRevocationListAttribute) {
         this.attributeCertificateRevocationListAttribute = attributeCertificateRevocationListAttribute;
         return this;
      }

      public Builder setAttributeAuthorityRevocationListAttribute(String attributeAuthorityRevocationListAttribute) {
         this.attributeAuthorityRevocationListAttribute = attributeAuthorityRevocationListAttribute;
         return this;
      }

      public Builder setLdapUserCertificateAttributeName(String ldapUserCertificateAttributeName) {
         this.ldapUserCertificateAttributeName = ldapUserCertificateAttributeName;
         return this;
      }

      public Builder setLdapCACertificateAttributeName(String ldapCACertificateAttributeName) {
         this.ldapCACertificateAttributeName = ldapCACertificateAttributeName;
         return this;
      }

      public Builder setLdapCrossCertificateAttributeName(String ldapCrossCertificateAttributeName) {
         this.ldapCrossCertificateAttributeName = ldapCrossCertificateAttributeName;
         return this;
      }

      public Builder setLdapCertificateRevocationListAttributeName(String ldapCertificateRevocationListAttributeName) {
         this.ldapCertificateRevocationListAttributeName = ldapCertificateRevocationListAttributeName;
         return this;
      }

      public Builder setLdapDeltaRevocationListAttributeName(String ldapDeltaRevocationListAttributeName) {
         this.ldapDeltaRevocationListAttributeName = ldapDeltaRevocationListAttributeName;
         return this;
      }

      public Builder setLdapAuthorityRevocationListAttributeName(String ldapAuthorityRevocationListAttributeName) {
         this.ldapAuthorityRevocationListAttributeName = ldapAuthorityRevocationListAttributeName;
         return this;
      }

      public Builder setLdapAttributeCertificateAttributeAttributeName(String ldapAttributeCertificateAttributeAttributeName) {
         this.ldapAttributeCertificateAttributeAttributeName = ldapAttributeCertificateAttributeAttributeName;
         return this;
      }

      public Builder setLdapAACertificateAttributeName(String ldapAACertificateAttributeName) {
         this.ldapAACertificateAttributeName = ldapAACertificateAttributeName;
         return this;
      }

      public Builder setLdapAttributeDescriptorCertificateAttributeName(String ldapAttributeDescriptorCertificateAttributeName) {
         this.ldapAttributeDescriptorCertificateAttributeName = ldapAttributeDescriptorCertificateAttributeName;
         return this;
      }

      public Builder setLdapAttributeCertificateRevocationListAttributeName(String ldapAttributeCertificateRevocationListAttributeName) {
         this.ldapAttributeCertificateRevocationListAttributeName = ldapAttributeCertificateRevocationListAttributeName;
         return this;
      }

      public Builder setLdapAttributeAuthorityRevocationListAttributeName(String ldapAttributeAuthorityRevocationListAttributeName) {
         this.ldapAttributeAuthorityRevocationListAttributeName = ldapAttributeAuthorityRevocationListAttributeName;
         return this;
      }

      public Builder setUserCertificateSubjectAttributeName(String userCertificateSubjectAttributeName) {
         this.userCertificateSubjectAttributeName = userCertificateSubjectAttributeName;
         return this;
      }

      public Builder setCACertificateSubjectAttributeName(String cACertificateSubjectAttributeName) {
         this.cACertificateSubjectAttributeName = cACertificateSubjectAttributeName;
         return this;
      }

      public Builder setCrossCertificateSubjectAttributeName(String crossCertificateSubjectAttributeName) {
         this.crossCertificateSubjectAttributeName = crossCertificateSubjectAttributeName;
         return this;
      }

      public Builder setCertificateRevocationListIssuerAttributeName(String certificateRevocationListIssuerAttributeName) {
         this.certificateRevocationListIssuerAttributeName = certificateRevocationListIssuerAttributeName;
         return this;
      }

      public Builder setDeltaRevocationListIssuerAttributeName(String deltaRevocationListIssuerAttributeName) {
         this.deltaRevocationListIssuerAttributeName = deltaRevocationListIssuerAttributeName;
         return this;
      }

      public Builder setAuthorityRevocationListIssuerAttributeName(String authorityRevocationListIssuerAttributeName) {
         this.authorityRevocationListIssuerAttributeName = authorityRevocationListIssuerAttributeName;
         return this;
      }

      public Builder setAttributeCertificateAttributeSubjectAttributeName(String attributeCertificateAttributeSubjectAttributeName) {
         this.attributeCertificateAttributeSubjectAttributeName = attributeCertificateAttributeSubjectAttributeName;
         return this;
      }

      public Builder setAACertificateSubjectAttributeName(String aACertificateSubjectAttributeName) {
         this.aACertificateSubjectAttributeName = aACertificateSubjectAttributeName;
         return this;
      }

      public Builder setAttributeDescriptorCertificateSubjectAttributeName(String attributeDescriptorCertificateSubjectAttributeName) {
         this.attributeDescriptorCertificateSubjectAttributeName = attributeDescriptorCertificateSubjectAttributeName;
         return this;
      }

      public Builder setAttributeCertificateRevocationListIssuerAttributeName(String attributeCertificateRevocationListIssuerAttributeName) {
         this.attributeCertificateRevocationListIssuerAttributeName = attributeCertificateRevocationListIssuerAttributeName;
         return this;
      }

      public Builder setAttributeAuthorityRevocationListIssuerAttributeName(String attributeAuthorityRevocationListIssuerAttributeName) {
         this.attributeAuthorityRevocationListIssuerAttributeName = attributeAuthorityRevocationListIssuerAttributeName;
         return this;
      }

      public Builder setSearchForSerialNumberIn(String searchForSerialNumberIn) {
         this.searchForSerialNumberIn = searchForSerialNumberIn;
         return this;
      }

      public X509LDAPCertStoreParameters build() {
         if (this.ldapUserCertificateAttributeName != null && this.ldapCACertificateAttributeName != null && this.ldapCrossCertificateAttributeName != null && this.ldapCertificateRevocationListAttributeName != null && this.ldapDeltaRevocationListAttributeName != null && this.ldapAuthorityRevocationListAttributeName != null && this.ldapAttributeCertificateAttributeAttributeName != null && this.ldapAACertificateAttributeName != null && this.ldapAttributeDescriptorCertificateAttributeName != null && this.ldapAttributeCertificateRevocationListAttributeName != null && this.ldapAttributeAuthorityRevocationListAttributeName != null && this.userCertificateSubjectAttributeName != null && this.cACertificateSubjectAttributeName != null && this.crossCertificateSubjectAttributeName != null && this.certificateRevocationListIssuerAttributeName != null && this.deltaRevocationListIssuerAttributeName != null && this.authorityRevocationListIssuerAttributeName != null && this.attributeCertificateAttributeSubjectAttributeName != null && this.aACertificateSubjectAttributeName != null && this.attributeDescriptorCertificateSubjectAttributeName != null && this.attributeCertificateRevocationListIssuerAttributeName != null && this.attributeAuthorityRevocationListIssuerAttributeName != null) {
            return new X509LDAPCertStoreParameters(this, (X509LDAPCertStoreParameters)null);
         } else {
            throw new IllegalArgumentException("Necessary parameters not specified.");
         }
      }
   }
}
